import * as echarts from "echarts";
import { handelBtcPrice,dataLength,  emptyData,chartsWidth, handelProfitrate, handelZoom, fetchBtcPrice, handelWatermark, fetchEthPrice, handelSmaData, getDateArray } from "../../util/processingData"
import { MVRVZ } from "../../api/pages"
export default {
    data() {
        return {
            lengthTimer:null,
            MVRVZLoading: false,
            params: {
                start: "",
                end: "",
                sma: 0
            },
            option: {
                tooltip: {
                    trigger: "axis",
                    //解决tooltip显示不全问题1 
                    confine: true,
                    formatter: function (params) {
                        const date = new Date(params[0].value[0]);
                        const year = date.getFullYear();
                        const month = date.getMonth() + 1;
                        const day = date.getDate();
                        let time =  `${year}-${month}-${day}`;
                        var res =time                       

                        for (let i = 0; i < params.length; i++) {
                            res += `</br>${params[i].marker} ${params[i].seriesName} &nbsp&nbsp&nbsp&nbsp <span style="font-weight: bold">${params[i].value[1]}</span>`

                        }
                        return res;
                    }
                },
                legend: {
                    right: "100",
                    // data:[`sopr`,'asopr','easopr','lthsopr','sthsopr',],
                    // selected:{
                    //     'asopr': false,
                    //     'easopr': false,
                    //     'lthsopr': false,
                    //     'sthsopr': false,                      
                    // }
                },
                xAxis: {
                    type: "time",
                    boundaryGap: false,
                    //   axisLabel: {
                    //     formatter: `{yyyy}-{MM}-{dd}`,
                    //   },
                    data: []
                },
                yAxis: [
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        axisLabel: {
                            formatter: function (e) {

                                let value;
                                if (e > 100000000) {
                                    value = `${e / 100000000}E`;
                                } else if (e > 1000000) {//百万
                                    value = `${e / 1000000}M`;
                                } else if (e > 10000) {//万
                                    value = `${e / 10000}W`;
                                } else {
                                    value = e;
                                }
                                return value;
                            },
                        },
                        min: "dataMin",
                        max: "dataMax",

                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: true,
                        position: "right",
                        min: "dataMin",
                        max: "dataMax",

                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: false,
                        position: "right",
                        min: "dataMin",
                        max: "dataMax",

                    },

                ],
                dataZoom: [
                    {
                        type: "inside",
                        start: 0,
                        end: 100,
                    },
                    {
                        start: 0,
                        end: 100,
                    },
                ],
                series: [
                    {
                        name: "MVRV Z-Score",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        showSymbol: false,
                        symbolSize: 5,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#f7931a",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#f7931a",
                            width: "1",
                        },
                        data: [],
                        markArea: {
                            silent: true,
                            data: [
                                [
                                    {
                                        yAxis: "-0.25",
                                        itemStyle: {
                                            color: "#e5f7f0",
                                        },
                                    },
                                    {
                                        yAxis: "0",
                                    },
                                ],
                                [
                                    {
                                        yAxis: "6.5",
                                        itemStyle: {
                                            color: "#fde7e7",
                                        },
                                    },
                                    {
                                        yAxis: "7.5",
                                    },
                                ],

                                //  如果有多种颜色，就继续在这里写区间数组，复制上面的下来改颜色
                            ],
                        }
                    },
                    {
                        name: "Price[BTC]",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        symbolSize: 5,
                        showSymbol: false,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#888888",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#888888",
                            width: "1",
                        },
                        yAxisIndex: 1,
                        data: [],
                        //绘制右侧Y轴
                        markLine: {
                            symbol: ["none", "none"], //去掉箭头
                            itemStyle: {
                                normal: {
                                    lineStyle: { type: "solid", color: "rgba(0,0,0,0.01)" },
                                },
                            },
                            // lineStyle:{
                            //   color:"red"
                            // },

                            label: {
                                formatter: "{b}",
                                fontSize: 10,
                                color: "rgba(0,0,0,0.8)",
                                align: "left",
                            },
                            data: [
                                // {
                                //     name: "0",
                                //     yAxis: 0,
                                // },
                                //  {
                                //   name: "$40W",
                                //   yAxis: 400000,
                                // },
                                {
                                    name: "$70W",
                                    yAxis: 700000,
                                },
                                {
                                    name: "$40W",
                                    yAxis: 400000,
                                },

                                {
                                    name: "$10W",
                                    yAxis: 100000,
                                },
                                {
                                    name: "$100W",
                                    yAxis: 1000000,
                                    // position: ['100%', '50'],
                                },
                                {
                                    name: "$120W",
                                    yAxis: 1200000,
                                },

                                {
                                    name: "$140W",
                                    yAxis: 1400000,
                                },
                            ],
                        },
                    },
                    // {
                    //     name: "Price [ETH]",
                    //     type: "line",
                    //     smooth: false, //线条是否圆滑
                    //     symbol: "circle",
                    //     symbolSize: 5,
                    //     showSymbol: false,
                    //     itemStyle: {
                    //         color: "#627eea",
                    //         borderColor: "rgba(221,220,107,0.1)",
                    //         borderWidth: 12,
                    //     },
                    //     lineStyle: {
                    //         //线条样式
                    //         color: "#627eea",
                    //         width: "1",
                    //     },
                    //     yAxisIndex: 2,
                    //     data: [],
                    // },

                ],
            },
            btcFlag: null,
            ethFlag: null,
            fatherSmaData: [],
            start: "",
            end: "",
            sma: "",
            zoomStart: 0,
            zoomEnd: 0,

        }
    },
    mounted() {


        this.fetchMVRVZ()
        this.ethFlag = JSON.parse(localStorage.getItem("ethFlag"));
        this.btcFlag = JSON.parse(localStorage.getItem("btcFlag"));
        this.$addStorageEvent(1, "zoomStart", this.zoomStart);
        this.$addStorageEvent(1, "zoomEnd", this.zoomEnd);
        window.addEventListener("setItem", () => {
            this.ethFlag = JSON.parse(localStorage.getItem("ethFlag"));
            this.btcFlag = JSON.parse(localStorage.getItem("btcFlag"));
            this.zoomStart = localStorage.getItem("zoomStart")
            this.zoomEnd = localStorage.getItem("zoomEnd")

        })
    },
    methods: {
        //初始化图表
        inCharts() {
            if (this.myChart == null) {
                this.myChart = echarts.init(document.getElementById("MVRVZBox"));
            }
            this.option = handelZoom(this.myChart, this.option, this, this.zoomStart, this.zoomEnd)

            this.myChart.setOption(this.option);
            chartsWidth("MVRVZBox", this);
            window.addEventListener("resize", () => {
                if (this.myChart) this.myChart.resize();
            });
        },
        async fetchMVRVZ(params) {
            this.MVRVZLoading = true
            // const { data } = await this.$API.getActiveaddress(req, this.params.coin, start, end,sma)

            const { data } = await MVRVZ(params)

            let mvrvzData = data.data
            //空数据处理
            let noData = emptyData(data.data, this.option.series, this.inCharts, this)
            if (noData) {
                this.MVRVZLoading = false
                return
            }
         
            this.start = mvrvzData[0].date.split("T")[0]
            this.end = mvrvzData[mvrvzData.length - 1].date.split("T")[0]
            //添加水印
            this.option = handelWatermark(this.option)
            //根据渲染的数据时间渲染对应的价格线和移动平均线
            // this.$nextTick(() => {
            //     //移动平均线没值 才渲染正常价格数据 
            //     if (this.start && !this.fatherSmaData[0]) {
            //         this.handelSonBtcPrice("BTC", true)
            //     }
            //     //点击时间 移动平均线有值 就渲染查询移动平均线
            //     if (this.fatherSmaData[0] && this.start) {
            //         this.handelSonSma(this.fatherSmaData, this.start, this.end)
            //     }
            //      //渲染ETH
            //      if (this.ethFlag) {                 
            //         this.$addStorageEvent(1, "ethFlag", JSON.stringify(this.ethFlag));
            //         this.handelSonEthPrice("ETH",this.ethFlag)
            //     }
            // })

            this.handelSonBtcPrice("BTC", true)
            let MVRVZValueList = []
            mvrvzData.forEach(item => {
                MVRVZValueList.push(Number(item.value).toFixed(2))

            })
            this.option.series[0].data = handelProfitrate(mvrvzData, MVRVZValueList)

            this.inCharts()
            this.MVRVZLoading = false

            //判定页面条数是否一致
            if (this.lengthTimer) {
                clearTimeout(this.lengthTimer)
            }
            this.lengthTimer = setTimeout(() => {

                this.$addStorageEvent(1, "lengthFlag", dataLength(this.option, this.option.series[0].data.length), );

            }, 10000)

        },
        // 请求BTC价格
        async fetchBtcPrice(radius, start, end) {
            //请求BTC价格
            const price = await this.$API.getBtcPrice2(radius, start, end);
            this.btcPrice = price.data.data
            if (!this.btcPrice) {//价格未查询到数据的情况              
                this.option.series[1].data.length = 0

            } else {

                let priceValueList = []
                let newPriceData = []
                this.btcPrice.forEach(price => {
                    priceValueList.push(Number(parseInt(price.value * 100) / 100))
                    newPriceData.push(price)
                })
                this.option.series[1].data = handelBtcPrice(newPriceData, priceValueList)

            }

            this.inCharts()
        },
        // 请求Eth价格
        async fetchEthPrice(radius, start, end) {
            const price = await this.$API.getBtcPrice2(radius, start, end);
            this.ethPrice = price.data.data
            if (!this.ethPrice) {
                this.option.series[2].data.length = 0
            } else {
                let priceValueList = []
                let newPriceData = []
                this.ethPrice.forEach(price => {
                    priceValueList.push(Number(parseInt(price.value * 100) / 100))
                    newPriceData.push(price)
                })
                this.option.series[2].data = handelBtcPrice(newPriceData, priceValueList)
            }

            this.inCharts()
        },
        //接收Home传的时间handelParmesTime
        handelSonTime(start, end) {
            this.params.start = start;
            this.params.end = end;
            this.fetchMVRVZ(this.params)
        },

        //父级点击BTC价格按钮
        handelSonBtcPrice(radius, flag) {
            this.btcFlag = flag

            fetchBtcPrice("BTC", this.option.series[1], this.start, this.end, this.inCharts, this, this.btcFlag)

        },
        //父级点击ETH价格按钮
        handelSonEthPrice(radius, flag) {
            this.ethFlag = flag
            this.$addStorageEvent(1, "ethFlag", JSON.stringify(this.ethFlag));
            fetchEthPrice("ETH", this.option.series[2], this.start, this.end, this.inCharts, this, this.ethFlag)


        },
        //父级选择Sma
        handelSonSma(smaDataList) {
            this.sma = smaDataList
            this.params.sma = smaDataList
            this.fetchMVRVZ(this.params)

            this.$addStorageEvent(1, "sma", this.sma);



            // this.fatherSmaData = smaDataList
            // handelSmaData(smaDataList, this.option.series[1], this.inCharts,this.start, this.end,)

        },


    },
    beforeDestroy() {
        if (this.lengthTimer) {
            clearTimeout(this.lengthTimer)
        }
    }
}